package com.wefanbot.winbot;


import com.wefanbot.winbot.util.ProUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.CountDownLatch;

/**
 * @author chenanlian
 */
public class Main {

    private static final Logger log = LoggerFactory.getLogger(Main.class);

    /**
     * 控制主线程是否结束
     */
    public static volatile CountDownLatch countDownLatchMain = new CountDownLatch(1);

    public static long lastTime = System.currentTimeMillis();

    public static Frame f = null;


    public static void main(String[] args) throws Exception {
        try {
            long startTime = System.currentTimeMillis();
            log.info("args:{}", args);
            String javaHome = System.getProperty("java.home");
            log.info("java home is {}", javaHome);
            //加载配置
            initEnv(args);

            CountDownLatch countDownLatchFrame = new CountDownLatch(1);
            javax.swing.SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    f = new Frame(300, 100, 0);
                    countDownLatchFrame.countDown();
                }
            });

            try {
                countDownLatchFrame.await();
            } catch (InterruptedException e) {
                log.info("初始化完毕");
            }
            f.setVisible(true);


            log.info("【程序启动】注册已经完成。耗时={}。", System.currentTimeMillis() - startTime);

            countDownLatchMain.await();
            log.info("停止程序......");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
    }


    public static void initEnv(String[] args) {
        log.info("Environment properties init start......");
        Long envInitStart = System.currentTimeMillis();
        for (String arg : args) {
            if (arg.startsWith("server.profiles.active=")) {
                ProUtil.innerEnv = false;
                ProUtil.env = arg.substring(23);
                log.info("启动参数配置环境：{}", ProUtil.env);
                break;
            }
        }
        ProUtil.init();
        log.info("配置参数：{}", ProUtil.string());

        log.info("Environment properties init end, cost time:{}ms.", System.currentTimeMillis() - envInitStart);
    }

}
